Index: /trunk/src/lib/libc/gen/isfinitel_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/isfinitel_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/isfinitel_ieee754.c	(revision 152)
@@ -0,0 +1,57 @@
+/*	$NetBSD: isfinitel_ieee754.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $	*/
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Matt Thomas.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: isfinitel_ieee754.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $");
+#endif
+
+#include <machine/ieee.h>
+#include <math.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+/*
+ * 7.12.3.2 isfinite - determine whether an argument has finite value
+ *          IEEE 754 compatible 128-bit extended-precision version
+ */
+int
+__isfinitel(long double x)
+{
+	union ieee_ext_u u;
+
+	u.extu_ld = x;
+
+	if (u.extu_ext.ext_exp == EXT_EXP_INFNAN)
+		return 0;
+
+	return 1;
+}
+#endif /* __HAVE_LONG_DOUBLE */
Index: /trunk/src/lib/libc/gen/isinfl_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/isinfl_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/isinfl_ieee754.c	(revision 152)
@@ -0,0 +1,66 @@
+/*	$NetBSD: isinfl_ieee754.c,v 1.4.4.2 2011/04/29 07:48:35 matt Exp $	*/
+
+/*
+ * Copyright (c) 1992, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This software was developed by the Computer Systems Engineering group
+ * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
+ * contributed to Berkeley.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * from: Header: isinf.c,v 1.1 91/07/08 19:03:34 torek Exp
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)isinf.c	8.1 (Berkeley) 6/4/93";
+#else
+__RCSID("$NetBSD: isinfl_ieee754.c,v 1.4.4.2 2011/04/29 07:48:35 matt Exp $");
+#endif
+#endif /* LIBC_SCCS and not lint */
+
+#include <machine/ieee.h>
+#include <math.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+/*
+ * 7.12.3.3 isinf - test for infinity
+ *          IEEE 754 compatible 128-bit extended-precision version
+ */
+int
+__isinfl(long double x)
+{
+	union ieee_ext_u u;
+
+	u.extu_ld = x;
+
+	return u.extu_ext.ext_exp == EXT_EXP_INFNAN
+	    && u.extu_ext.ext_frach == 0 && u.extu_ext.ext_frachm == 0
+	    && u.extu_ext.ext_fraclm == 0 && u.extu_ext.ext_fracl == 0;
+}
+#endif /* __HAVE_LONG_DOUBLE */
Index: /trunk/src/lib/libc/gen/isnanl_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/isnanl_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/isnanl_ieee754.c	(revision 152)
@@ -0,0 +1,66 @@
+/*	$NetBSD: isnanl_ieee754.c,v 1.6.4.2 2011/04/29 07:48:35 matt Exp $	*/
+
+/*
+ * Copyright (c) 1992, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This software was developed by the Computer Systems Engineering group
+ * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
+ * contributed to Berkeley.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * from: Header: isinf.c,v 1.1 91/07/08 19:03:34 torek Exp
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)isinf.c	8.1 (Berkeley) 6/4/93";
+#else
+__RCSID("$NetBSD: isnanl_ieee754.c,v 1.6.4.2 2011/04/29 07:48:35 matt Exp $");
+#endif
+#endif /* LIBC_SCCS and not lint */
+
+#include <machine/ieee.h>
+#include <math.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+/*
+ * 7.12.3.4 isnan - test for a NaN
+ *          IEEE 754 compatible 128-bit extended-precision version
+ */
+int
+__isnanl(long double x)
+{
+	union ieee_ext_u u;
+
+	u.extu_ld = x;
+
+	return u.extu_ext.ext_exp == EXT_EXP_INFNAN 
+	    && (u.extu_ext.ext_frach != 0 || u.extu_ext.ext_frachm != 0
+	        || u.extu_ext.ext_fraclm != 0 || u.extu_ext.ext_fracl != 0);
+}
+#endif /* __HAVE_LONG_DOUBLE */
Index: /trunk/src/lib/libc/gen/signbitl_ieee754.c
===================================================================
--- /trunk/src/lib/libc/gen/signbitl_ieee754.c	(revision 152)
+++ /trunk/src/lib/libc/gen/signbitl_ieee754.c	(revision 152)
@@ -0,0 +1,56 @@
+/*	$NetBSD: signbitl_ieee754.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $	*/
+
+/*-
+ * Copyright (c) 2003 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Klaus Klein.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD");
+#endif
+
+#include <machine/ieee.h>
+#include <math.h>
+
+#ifdef __HAVE_LONG_DOUBLE
+
+/*
+ * 7.12.3.6 signbit - determine whether the sign of an argument is negative
+ *          IEEE 754 compatible 128-bit extended-precision version
+ */
+int
+__signbitl(long double x)
+{
+	union ieee_ext_u u;
+
+	u.extu_ld = x;
+
+	return (u.extu_ext.ext_sign == 1);
+}
+
+#endif /* __HAVE_LONG_DOUBLE */
Index: /trunk/src/lib/libc/misc/initfini.c
===================================================================
--- /trunk/src/lib/libc/misc/initfini.c	(revision 151)
+++ /trunk/src/lib/libc/misc/initfini.c	(revision 152)
@@ -1,3 +1,3 @@
-/* 	$NetBSD: initfini.c,v 1.5 2008/04/28 20:23:00 martin Exp $	 */
+/* 	$NetBSD: initfini.c,v 1.5.14.1 2011/05/20 08:11:17 matt Exp $	 */
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__RCSID("$NetBSD: initfini.c,v 1.5 2008/04/28 20:23:00 martin Exp $");
+__RCSID("$NetBSD: initfini.c,v 1.5.14.1 2011/05/20 08:11:17 matt Exp $");
 
 #ifdef _LIBC
@@ -37,5 +37,5 @@
 #endif
 
-static void	__libc_init(void) __attribute__((__constructor__, __used__));
+void	__libc_init(void) __attribute__((__constructor__, __used__));
 
 void	__guard_setup(void);
@@ -45,5 +45,5 @@
 
 /* LINTED used */
-static void
+void
 __libc_init(void)
 {
Index: /trunk/src/lib/libc/softfloat/Makefile.inc
===================================================================
--- /trunk/src/lib/libc/softfloat/Makefile.inc	(revision 151)
+++ /trunk/src/lib/libc/softfloat/Makefile.inc	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile.inc,v 1.4 2004/09/26 21:13:27 jmmv Exp $
+#	$NetBSD: Makefile.inc,v 1.4.40.1 2011/04/29 07:48:35 matt Exp $
 
 SOFTFLOAT_BITS?=64
@@ -8,10 +8,13 @@
 CPPFLAGS+=	-DSOFTFLOAT_FOR_GCC
 
-SRCS+=		softfloat.c
+SRCS.softfloat+=softfloat.c
 
-SRCS+=		fpgetround.c fpsetround.c fpgetmask.c fpsetmask.c \
+SRCS.softfloat+=fpgetround.c fpsetround.c fpgetmask.c fpsetmask.c \
 		fpgetsticky.c fpsetsticky.c
 
-SRCS+=		eqsf2.c nesf2.c gtsf2.c gesf2.c ltsf2.c lesf2.c negsf2.c \
+SRCS.softfloat+=eqsf2.c nesf2.c gtsf2.c gesf2.c ltsf2.c lesf2.c negsf2.c \
 		eqdf2.c nedf2.c gtdf2.c gedf2.c ltdf2.c ledf2.c negdf2.c \
+		eqtf2.c netf2.c gttf2.c getf2.c lttf2.c letf2.c negtf2.c \
 		nexf2.c gtxf2.c gexf2.c negxf2.c unordsf2.c unorddf2.c
+
+SRCS+=		${SRCS.softfloat}
Index: /trunk/src/lib/libc/softfloat/bits32/softfloat-macros
===================================================================
--- /trunk/src/lib/libc/softfloat/bits32/softfloat-macros	(revision 151)
+++ /trunk/src/lib/libc/softfloat/bits32/softfloat-macros	(revision 152)
@@ -312,5 +312,5 @@
     z0 = a0 + b0;
     z1 += carry1;
-    z0 += ( z1 < carry1 );
+    z0 += ( z1 < (bits32)carry1 );
     z0 += carry0;
     *z2Ptr = z2;
@@ -369,5 +369,5 @@
     borrow0 = ( a1 < b1 );
     z0 = a0 - b0;
-    z0 -= ( z1 < borrow1 );
+    z0 -= ( z1 < (bits32)borrow1 );
     z1 -= borrow1;
     z0 -= borrow0;
Index: /trunk/src/lib/libc/softfloat/bits64/softfloat-macros
===================================================================
--- /trunk/src/lib/libc/softfloat/bits64/softfloat-macros	(revision 151)
+++ /trunk/src/lib/libc/softfloat/bits64/softfloat-macros	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: softfloat-macros,v 1.1 2002/05/21 23:51:08 bjh21 Exp $ */
+/* $NetBSD: softfloat-macros,v 1.1.50.1 2011/05/28 20:28:55 matt Exp $ */
 
 /*
@@ -387,5 +387,5 @@
     z0 = a0 + b0;
     z1 += carry1;
-    z0 += ( z1 < carry1 );
+    z0 += ( z1 < (bits64)carry1 );
     z0 += carry0;
     *z2Ptr = z2;
@@ -444,5 +444,5 @@
     borrow0 = ( a1 < b1 );
     z0 = a0 - b0;
-    z0 -= ( z1 < borrow1 );
+    z0 -= ( z1 < (bits64)borrow1 );
     z1 -= borrow1;
     z0 -= borrow0;
Index: /trunk/src/lib/libc/softfloat/bits64/softfloat.c
===================================================================
--- /trunk/src/lib/libc/softfloat/bits64/softfloat.c	(revision 151)
+++ /trunk/src/lib/libc/softfloat/bits64/softfloat.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: softfloat.c,v 1.5 2007/11/08 21:31:04 martin Exp $ */
+/* softfloat.c,v 1.5 2007/11/08 21:31:04 martin Exp */
 
 /*
@@ -47,5 +47,5 @@
 #include <sys/cdefs.h>
 #if defined(LIBC_SCCS) && !defined(lint)
-__RCSID("$NetBSD: softfloat.c,v 1.5 2007/11/08 21:31:04 martin Exp $");
+__RCSID("softfloat.c,v 1.5 2007/11/08 21:31:04 martin Exp");
 #endif /* LIBC_SCCS and not lint */
 
@@ -4336,4 +4336,44 @@
 
 /*
+ * just like above - but do not care for overflow of signed results
+ */
+unsigned int float128_to_uint32_round_to_zero( float128 a )
+{
+    flag aSign;
+    int32 aExp, shiftCount;
+    bits64 aSig0, aSig1, savedASig;
+    uint32 z;
+
+    aSig1 = extractFloat128Frac1( a );
+    aSig0 = extractFloat128Frac0( a );
+    aExp = extractFloat128Exp( a );
+    aSign = extractFloat128Sign( a );
+    aSig0 |= ( aSig1 != 0 );
+    if ( 0x401E < aExp ) {
+        if ( ( aExp == 0x7FFF ) && aSig0 ) aSign = 0;
+        goto invalid;
+    }
+    else if ( aExp < 0x3FFF ) {
+        if ( aExp || aSig0 ) float_exception_flags |= float_flag_inexact;
+        return 0;
+    }
+    aSig0 |= LIT64( 0x0001000000000000 );
+    shiftCount = 0x402F - aExp;
+    savedASig = aSig0;
+    aSig0 >>= shiftCount;
+    z = aSig0;
+    if ( aSign ) {
+ invalid:
+        float_raise( float_flag_invalid );
+        return 0xFFFFFFFF;
+    }
+    if ( ( aSig0<<shiftCount ) != savedASig ) {
+        float_exception_flags |= float_flag_inexact;
+    }
+    return z;
+
+}
+
+/*
 -------------------------------------------------------------------------------
 Returns the result of converting the quadruple-precision floating-point
Index: /trunk/src/lib/libc/softfloat/eqtf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/eqtf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/eqtf2.c	(revision 152)
@@ -0,0 +1,26 @@
+/* $NetBSD: eqtf2.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: eqtf2.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#ifdef FLOAT128
+flag __eqtf2(float128, float128);
+
+flag
+__eqtf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says !(a == b) */
+	return !float128_eq(a, b);
+}
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/getf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/getf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/getf2.c	(revision 152)
@@ -0,0 +1,28 @@
+/* $NetBSD: getf2.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: getf2.c,v 1.1.4.2 2011/04/29 07:48:35 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+flag __getf2(float128, float128);
+
+flag
+__getf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says (a >= b) - 1 */
+	return float128_le(b, a) - 1;
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/gttf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/gttf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/gttf2.c	(revision 152)
@@ -0,0 +1,28 @@
+/* $NetBSD: gttf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: gttf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+flag __gttf2(float128, float128);
+
+flag
+__gttf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says a > b */
+	return float128_lt(b, a);
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/letf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/letf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/letf2.c	(revision 152)
@@ -0,0 +1,28 @@
+/* $NetBSD: letf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: letf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+flag __letf2(float128, float128);
+
+flag
+__letf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says 1 - (a <= b) */
+	return 1 - float128_le(a, b);
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/lttf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/lttf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/lttf2.c	(revision 152)
@@ -0,0 +1,28 @@
+/* $NetBSD: lttf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: lttf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+flag __lttf2(float128, float128);
+
+flag
+__lttf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says -(a < b) */
+	return -float128_lt(a, b);
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/negtf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/negtf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/negtf2.c	(revision 152)
@@ -0,0 +1,29 @@
+/* $NetBSD: negtf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: negtf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+float128 __negtf2(float128);
+
+float128
+__negtf2(float128 a)
+{
+
+	/* libgcc1.c says -a */
+	a.high ^= FLOAT64_MANGLE(0x8000000000000000ULL);
+	return a;
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/softfloat/netf2.c
===================================================================
--- /trunk/src/lib/libc/softfloat/netf2.c	(revision 152)
+++ /trunk/src/lib/libc/softfloat/netf2.c	(revision 152)
@@ -0,0 +1,28 @@
+/* $NetBSD: netf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $ */
+
+/*
+ * Written by Matt Thomas, 2011.  This file is in the Public Domain.
+ */
+
+#include "softfloat-for-gcc.h"
+#include "milieu.h"
+#include "softfloat.h"
+
+#include <sys/cdefs.h>
+#if defined(LIBC_SCCS) && !defined(lint)
+__RCSID("$NetBSD: netf2.c,v 1.1.4.2 2011/04/29 07:48:36 matt Exp $");
+#endif /* LIBC_SCCS and not lint */
+
+#ifdef FLOAT128
+
+flag __netf2(float128, float128);
+
+flag
+__netf2(float128 a, float128 b)
+{
+
+	/* libgcc1.c says a != b */
+	return !float128_eq(a, b);
+}
+
+#endif /* FLOAT128 */
Index: /trunk/src/lib/libc/stdlib/exit.c
===================================================================
--- /trunk/src/lib/libc/stdlib/exit.c	(revision 151)
+++ /trunk/src/lib/libc/stdlib/exit.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: exit.c,v 1.11 2007/10/30 17:19:59 skrll Exp $	*/
+/*	$NetBSD: exit.c,v 1.11.20.1 2011/05/20 08:11:17 matt Exp $	*/
 
 /*-
@@ -35,5 +35,5 @@
 static char sccsid[] = "@(#)exit.c	8.1 (Berkeley) 6/4/93";
 #else
-__RCSID("$NetBSD: exit.c,v 1.11 2007/10/30 17:19:59 skrll Exp $");
+__RCSID("$NetBSD: exit.c,v 1.11.20.1 2011/05/20 08:11:17 matt Exp $");
 #endif
 #endif /* LIBC_SCCS and not lint */
@@ -46,4 +46,11 @@
 #endif
 
+#ifdef _LIBC
+extern void __libc_init(void);
+#ifndef __lint
+static void (*force_ref)(void) __used = __libc_init;
+#endif
+#endif
+
 void (*__cleanup) __P((void));
 
@@ -52,6 +59,5 @@
  */
 void
-exit(status)
-	int status;
+exit(int status)
 {
 
Index: /trunk/src/lib/libpthread/arch/mips/_context_u.S
===================================================================
--- /trunk/src/lib/libpthread/arch/mips/_context_u.S	(revision 151)
+++ /trunk/src/lib/libpthread/arch/mips/_context_u.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: _context_u.S,v 1.3.14.2 2009/08/24 02:35:05 matt Exp $	*/
+/*	$NetBSD: _context_u.S,v 1.3.14.3 2011/04/29 08:01:52 matt Exp $	*/
 
 /*
@@ -33,5 +33,4 @@
 #include "SYS.h"
 #include <machine/asm.h>
-#include <machine/mcontext.h>
 
 /*
Index: /trunk/src/lib/libpthread/pthread.c
===================================================================
--- /trunk/src/lib/libpthread/pthread.c	(revision 151)
+++ /trunk/src/lib/libpthread/pthread.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pthread.c,v 1.106.2.1.4.1 2010/04/21 05:28:11 matt Exp $	*/
+/*	$NetBSD: pthread.c,v 1.106.2.1.4.2 2011/05/20 08:11:18 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__RCSID("$NetBSD: pthread.c,v 1.106.2.1.4.1 2010/04/21 05:28:11 matt Exp $");
+__RCSID("$NetBSD: pthread.c,v 1.106.2.1.4.2 2011/05/20 08:11:18 matt Exp $");
 
 #define	__EXPOSE_STACK	1
@@ -241,4 +241,5 @@
 pthread__fork_callback(void)
 {
+	struct __pthread_st *self;
 
 	/* lwpctl state is not copied across fork. */
@@ -246,4 +247,6 @@
 		err(1, "_lwp_ctl");
 	}
+	self = pthread__self();
+	self->pt_lid = _lwp_self();
 }
 
Index: /trunk/src/libexec/httpd/bozohttpd.c
===================================================================
--- /trunk/src/libexec/httpd/bozohttpd.c	(revision 151)
+++ /trunk/src/libexec/httpd/bozohttpd.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bozohttpd.c,v 1.7.8.3 2009/03/26 17:19:45 snj Exp $	*/
+/*	$NetBSD: bozohttpd.c,v 1.7.8.3.4.1 2011/05/20 08:11:18 matt Exp $	*/
 
 /*	$eterna: bozohttpd.c,v 1.142 2008/03/03 03:36:11 mrg Exp $	*/
@@ -112,5 +112,5 @@
 #endif
 #ifndef SERVER_SOFTWARE
-#define SERVER_SOFTWARE		"bozohttpd/20080303"
+#define SERVER_SOFTWARE		"bozohttpd/20080303-nb1"
 #endif
 #ifndef DIRECT_ACCESS_FILE
@@ -1039,4 +1039,7 @@
 		s = 0;
 		for (i = scandir(vpath, &list, 0, 0); i--; list++) {
+			if (strcmp((*list)->d_name, ".") == 0 ||
+			    strcmp((*list)->d_name, "..") == 0)
+				continue;
 			debug((DEBUG_OBESE, "looking at dir``%s''",
 			    (*list)->d_name));
Index: /trunk/src/libexec/ld.elf_so/arch/mips/mips_reloc.c
===================================================================
--- /trunk/src/libexec/ld.elf_so/arch/mips/mips_reloc.c	(revision 151)
+++ /trunk/src/libexec/ld.elf_so/arch/mips/mips_reloc.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_reloc.c,v 1.53.10.2 2009/09/05 18:53:13 matt Exp $	*/
+/*	$NetBSD: mips_reloc.c,v 1.53.10.3 2010/08/19 07:07:01 matt Exp $	*/
 
 /*
@@ -31,5 +31,5 @@
 #include <sys/cdefs.h>
 #ifndef lint
-__RCSID("$NetBSD: mips_reloc.c,v 1.53.10.2 2009/09/05 18:53:13 matt Exp $");
+__RCSID("$NetBSD: mips_reloc.c,v 1.53.10.3 2010/08/19 07:07:01 matt Exp $");
 #endif /* not lint */
 
@@ -76,4 +76,5 @@
 #define	Elf_Sxword			Elf32_Sword
 #endif
+#define	GOT1_MASK			(~(Elf_Addr)0 >> 1)
 
 static inline Elf_Sxword
@@ -426,9 +427,5 @@
 {
 	Elf_Addr *got = (Elf_Addr *)(a2 - 0x7ff0);
-#if 0
-	const Obj_Entry *obj = (Obj_Entry *)(got[1] & 0x7fffffff);
-#else
-	const Obj_Entry *obj = (Obj_Entry *)(got[1]);
-#endif
+	const Obj_Entry *obj = (Obj_Entry *)(got[1] & GOT1_MASK);
 	Elf_Addr new_value;
 	int err;
Index: /trunk/src/libexec/ld.elf_so/rtld.c
===================================================================
--- /trunk/src/libexec/ld.elf_so/rtld.c	(revision 151)
+++ /trunk/src/libexec/ld.elf_so/rtld.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: rtld.c,v 1.123.8.1 2010/04/21 05:26:10 matt Exp $	 */
+/*	$NetBSD: rtld.c,v 1.123.8.2 2010/08/19 15:35:18 matt Exp $	 */
 
 /*
@@ -41,5 +41,5 @@
 #include <sys/cdefs.h>
 #ifndef lint
-__RCSID("$NetBSD: rtld.c,v 1.123.8.1 2010/04/21 05:26:10 matt Exp $");
+__RCSID("$NetBSD: rtld.c,v 1.123.8.2 2010/08/19 15:35:18 matt Exp $");
 #endif /* not lint */
 
@@ -347,7 +347,11 @@
 				 * terminator */
 	env = (char **) sp;
+#if defined(RTLD_DEBUG)
+	dbg(("env is %p", env));
+#endif
 	while (*sp++ != 0) {	/* Skip over environment, and NULL terminator */
 #if defined(RTLD_DEBUG)
-		dbg(("env[%d] = %p %s", i++, (void *)sp[-1], (char *)sp[-1]));
+		dbg(("env[%d] = %p", i++, (void *)sp[-1]));
+		dbg(("%s", (char *)sp[-1]));
 #endif
 	}
Index: /trunk/src/sbin/disklabel/interact.c
===================================================================
--- /trunk/src/sbin/disklabel/interact.c	(revision 151)
+++ /trunk/src/sbin/disklabel/interact.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interact.c,v 1.30 2006/11/26 16:16:31 jmmv Exp $	*/
+/*	$NetBSD: interact.c,v 1.30.32.1 2011/05/20 08:11:18 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 #include <sys/cdefs.h>
 #ifndef lint
-__RCSID("$NetBSD: interact.c,v 1.30 2006/11/26 16:16:31 jmmv Exp $");
+__RCSID("$NetBSD: interact.c,v 1.30.32.1 2011/05/20 08:11:18 matt Exp $");
 #endif /* lint */
 
@@ -73,5 +73,5 @@
 static void	defnum(struct disklabel *, char *, uint32_t);
 static void	dumpnames(const char *, const char * const *, size_t);
-static int	getnum(struct disklabel *, char *, int);
+static intmax_t	getnum(struct disklabel *, char *, intmax_t);
 
 static int rounding = 0;	/* sector rounding */
@@ -450,4 +450,5 @@
 {
 	int	i;
+	intmax_t im;
 	char	line[BUFSIZ];
 	char	def[BUFSIZ];
@@ -509,12 +510,13 @@
 			}
 		} else {
-			if ((i = getnum(lp, line, 0)) == -1) {
+			if ((im = getnum(lp, line, 0)) == -1 || im < 0) {
 				printf("Bad offset `%s'\n", line);
 				continue;
-			} else if (i > lp->d_secperunit) {
+			} else if (im > 0xffffffffLL ||
+				   (uint32_t)im > lp->d_secperunit) {
 				printf("Offset `%s' out of range\n", line);
 				continue;
 			}
-			p->p_offset = i;
+			p->p_offset = (uint32_t)im;
 		}
 		break;
@@ -528,14 +530,14 @@
 		else if (i == 0)
 			break;
-		if ((i = getnum(lp, line, lp->d_secperunit - p->p_offset))
+		if ((im = getnum(lp, line, lp->d_secperunit - p->p_offset))
 		    == -1) {
 			printf("Bad size `%s'\n", line);
 			continue;
-		} else if
-		    ((i + p->p_offset) > lp->d_secperunit) {
+		} else if (im > 0xffffffffLL ||
+			   (im + p->p_offset) > lp->d_secperunit) {
 			printf("Size `%s' out of range\n", line);
 			continue;
 		}
-		p->p_size = i;
+		p->p_size = im;
 		break;
 	}
@@ -714,13 +716,13 @@
 
 
-static int
-getnum(struct disklabel *lp, char *buf, int max)
+static intmax_t
+getnum(struct disklabel *lp, char *buf, intmax_t defaultval)
 {
 	char	*ep;
 	double	 d;
-	int	 rv;
-
-	if (max && buf[0] == '$' && buf[1] == 0)
-		return max;
+	intmax_t rv;
+
+	if (defaultval && buf[0] == '$' && buf[1] == 0)
+		return defaultval;
 
 	d = strtod(buf, &ep);
@@ -735,30 +737,30 @@
 	case 's':
 	case 'S':
-		rv = (int) d;
+		rv = (intmax_t) d;
 		break;
 
 	case 'c':
 	case 'C':
-		rv = (int) (d * lp->d_secpercyl);
+		rv = (intmax_t) (d * lp->d_secpercyl);
 		break;
 
 	case 'k':
 	case 'K':
-		rv =  (int) (d * 1024 / lp->d_secsize);
+		rv =  (intmax_t) (d * 1024 / lp->d_secsize);
 		break;
 
 	case 'm':
 	case 'M':
-		rv =  (int) (d * 1024 * 1024 / lp->d_secsize);
+		rv =  (intmax_t) (d * 1024 * 1024 / lp->d_secsize);
 		break;
 
 	case 'g':
 	case 'G':
-		rv =  (int) (d * 1024 * 1024 * 1024 / lp->d_secsize);
+		rv =  (intmax_t) (d * 1024 * 1024 * 1024 / lp->d_secsize);
 		break;
 
 	case 't':
 	case 'T':
-		rv =  (int) (d * 1024 * 1024 * 1024 * 1024 / lp->d_secsize);
+		rv =  (intmax_t) (d * 1024 * 1024 * 1024 * 1024 / lp->d_secsize);
 		break;
 
Index: /trunk/src/sbin/newbtconf/Makefile
===================================================================
--- /trunk/src/sbin/newbtconf/Makefile	(revision 151)
+++ /trunk/src/sbin/newbtconf/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.1 1999/10/05 11:22:43 darrenr Exp $
+#	$NetBSD: Makefile,v 1.1.1.1 1999/10/05 11:22:43 darrenr Exp $
 #	@(#)Makefile	8.1 (Berkeley) 6/5/93
 
